#include <bits/stdc++.h>

using namespace std;

int solve();

#define ss second
#define ff first
#define y1 y111
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> ipair;
typedef pair <ll, ll> lpair;

const int MAXN = (int)2e5 + 7, IINF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7, MOD = (ll)1e9;
const double INFfl = (double)1e18 + 7, EPS = (double)1e-8, PI = atan2(0, -1);
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

mt19937 mmtw(4354353);
int rnd(int x) {
    static uniform_int_distribution<int> d;
    return d(mmtw) % x;
}

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
	return 0;
}

int prime[8] = {2, 3, 5, 7, 11, 13, 17, 19};

int solve() {
	int n, s;
	cin >> n >> s;
	s--;
	vector <int> a(n);
	vector <int> d(21);
	for (int i = 0; i < n; ++i) {
		 cin >> a[i];
		 for (int j = 0; j < 8; ++j) {
		 	int cnt = 0;
		 	while (a[i] % prime[j] == 0) {
		 		cnt++;
		 		a[i] /= prime[j];
		 	}
		 	d[prime[j]] = max(d[prime[j]], cnt);
		 }
	}
	ll ans = 1;
	for (int i = 0; i < 8; ++i) {
		while (d[prime[i]]--) ans *= prime[i];
	}
	cout << (ans + s) % 7 + 1 << "\n";
	return 0;
}
