#include <iostream>
#include <cstdio>
#include "testlib.h"

const int MAXN = (int)1e9;
const int MAXM = (int)5e3;

int up[(int)1e4 + 5];

int main(int argc, char *argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAXN, "high");
	inf.readSpace();
	int m = inf.readInt(1, MAXM, "weight");
	inf.readEoln();

	for (int i = 0; i < m; i++) {
		up[i] = inf.readInt(0, n, "filled from up");
		if (i + 1 != m) inf.readSpace();
	}
	inf.readEoln();

	for (int i = 0; i < m; i++) {
		int x = inf.readInt(0, n - up[i], "filled from down");
		if (i + 1 != m) inf.readSpace();
	}

	inf.readEoln();
	inf.readEof();
	return 0;
}	
