#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

ll ar_prog(ll l, ll r) {
	double tmp = (double) (r - l) * (l + r - 1) / 2;
	if (tmp < -INFL * 4) {
		return -INFL * 2;
	}
	ll ret = (r - l) * (l + r - 1) / 2;
	return ret;
}

void solve() {
	int n;
	ll t;
	cin >> n >> t;
	vector<int> inp;
	vector<ll> pref = {0};
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		inp.push_back(a);
		pref.push_back(pref.back() + a);
	}

	ll ans = *min_element(inp.begin(), inp.end());

	for (int i = 0; i < n; ++i) {
		ll lh = -t, rh = inp[i];
		while (rh - lh > 1) {
			ll midh = (lh + rh) / 2;
			int llg = -1, rlg = i;
			while (rlg - llg > 1) {
				int midl = (llg + rlg) / 2;
				if (inp[midl] <= midh + (i - midl)) {
					llg = midl;
				} else {
					rlg = midl;
				}
			}

			int lrg = i, rrg = n;
			while (rrg - lrg > 1) {
				int midr = (lrg + rrg) / 2;
				if (inp[midr] <= midh + (midr - i)) {
					rrg = midr;
				} else {
					lrg = midr;
				}
			}

			ll sum = pref[lrg + 1] - pref[rlg];
			sum -= ar_prog(midh, midh + (i - rlg) + 1) + ar_prog(midh + 1, midh + (lrg - i) + 1);
			assert(sum >= 0);
			if (sum > t) {
				lh = midh;
			} else {
				rh = midh;
			}
		}

		ans = min(ans, rh);
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
