#include "testlib.h"
#include <cmath>
#include <vector>
#include <algorithm>

const long long MAXN = 1000000000000000010;
const int ERR = 1000000;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    long long jans = ans.readLong();
    long long pans = ouf.readLong();
    if (pans < 0 || pans > MAXN) {
        quitf(_wa, "participant's answer violates the valid range");
    }
    if (abs(jans - pans) > 2 * ERR + 1) {
        quitf(_wa, "incorrect");
    }
    quitf(_ok, "jury says %lld, participant says %lld", jans, pans);
}
