#include "testlib.h"
#include <vector>
#include <cmath>

using namespace std;

const int MAXN = 100000;
const int MAXX = 1000000000;
const long long MAXANS = 1000000000000000000LL;
const long double EPS = 1e-5;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXN, "m");
    inf.readEoln();
    cerr << "okich" << endl;
    long double lg = 0;
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            inf.readSpace();
        }
        int a = inf.readInt(1, MAXX, format("a[%d]", i));
        lg += logl(a);
    }
    inf.readEoln();
    for (int i = 0; i < m; i++) {
        if (i != 0) {
            inf.readSpace();
        }
        int b = inf.readInt(1, MAXX, format("b[%d]", i));
        lg -= logl(b);
    }
    inf.readEoln();

    cerr << "lg = " << lg << endl;

    ensuref(lg + EPS < logl(MAXANS), "answer is too large");

    inf.readEof();
}
