#include <bits/stdc++.h>
using namespace std;


int const mod = 998244353;

void add(int &a, int b) {
    a += b;
    if (a >= mod) a -= mod;
}

int prod(int a, int b) {
    return (long long) a * b % mod;
}


vector<int> make_line(int n, int maxk, vector<int> const &inv) {
    vector<int> res(maxk + 1);
    res[0] = 1;
    for (int i = 1; i <= maxk; ++i) {
        res[i] = prod(res[i - 1], prod(inv[i], n - i + 1));
    }
    return res;
}


void solve() {
    int n;
    cin >> n;
    int a = 0;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a += x > 0;
    }
    int b = 0;
    for (int i = 0; i < n; ++i) {
        int y;
        cin >> y;
        b += y > 0;
    }

    vector<int> inv(n + 1);
    inv[1] = 1;
    for (int i = 2; i <= n; ++i) {
        inv[i] = prod(inv[mod % i], mod - mod / i);
    }

    auto ca = make_line(a, n, inv);
    auto cb = make_line(b, n, inv);
    auto cna = make_line(n - a, n, inv);
    auto cnb = make_line(n - b, n, inv);

    int ans = 0;
    for (int k = 0; k <= min(a, b); ++k) {
        add(ans, prod(prod(ca[k], cb[k]), prod(cnb[a - k], cna[b - k])));
    }
    cout << ans << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    int tests = 1;
    // cin >> tests;
    for (int i = 0; i < tests; ++i) {
        solve();
    }
}
