#include <bits/stdc++.h>
using namespace std;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int &x : a) {
        cin >> x;
    }
    vector<int> b(m);
    for (int &x : b) {
        cin >> x;
    }

    vector<int> maxa(a.begin(), a.end());
    vector<int> maxb(b.begin(), b.end());

    long long answer = 0;
    for (int width = 1; width <= m; ++width) {
        for (int i = 0; i < m - width; ++i) {
            maxa[i] = max(maxa[i], maxa[i + 1]);
            maxb[i] = max(maxb[i], maxb[i + 1]);
        }
        int window = min(width + 1, m);
        int height = n;
        for (int i = 0; i + window <= m; ++i) {
            height = min(height, n - maxa[i] - maxb[i]);
        }
        answer = max(answer, (long long) height * width);
    }

    cout << answer << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    int tests = 1;
    // cin >> tests;
    for (int i = 0; i < tests; ++i) {
        solve();
    }
}
