#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> field(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j];
		}
	}

	if (n > m) {
		vector<vector<char>> field2(m, vector<char>(n));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				field2[j][i] = field[i][j];
			}
		}
		swap(field, field2);
		swap(n, m);
	}

	vector<vector<int>> states;

	vector<int> cur(n, -1);
	vector<bool> used(n);
	map<ull, int> ind_state;
	vector<ull> hashes;
	function<void(int)> rec = [&](int pos) {
		if (pos == n) {
			states.push_back(cur);
			ull h = 0;
			for (int p : cur) {
				h = h * 23 + p + 1;
			}
			hashes.push_back(h);
			ind_state[h] = szof(states) - 1;
			// for (int num : cur) {
			// 	cerr << num << " ";
			// }
			// cerr << endl;
			return;
		}
		rec(pos + 1);
		if (!used[pos]) {
			for (int i = pos + 1; i < n; ++i) {
				if (used[i]) {
					break;
				}
				cur[pos] = i;
				cur[i] = pos;
				used[i] = true;
				rec(pos + 1);
				used[i] = false;
				cur[pos] = cur[i] = -1;
			}
		}
	};
	
	vector<ull> pow23 = {1};
	for (int i = 0; i < n; ++i) {
		pow23.push_back(pow23.back() * 23);
	}

	function<ull(int, int, int)> change = [&](int pos, int val1, int val2) {
		return pow23[n - pos - 1] * (val2 - val1);
	};

	rec(0);

	vector<vector<vector<vector<tuple<int, int, int, int>>>>> go(2, vector<vector<vector<tuple<int, int, int, int>>>>(n, vector<vector<tuple<int, int, int, int>>>(szof(states))));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < szof(states); ++j) {
			for (int last = 0; last < 2; ++last) {
				if (last && i > 0 && states[j][i - 1] != -1) {
					continue;
				}
				int mask = 0;
				if (states[j][i] != -1) {
					mask |= 2;
				}
				go[last][i][j].push_back({mask, j, 0, 0});
				if (i) {
					if (states[j][i] != -1 && states[j][i - 1] != -1) {
						if (states[j][i] == i - 1 && states[j][i - 1] == i) {
							ull nh = hashes[j] + change(i, states[j][i], -1) + change(i - 1, states[j][i - 1], -1);
							go[last][i][j].push_back({mask | 1, ind_state[nh], 1, 1});
						} else {
							int u1 = states[j][i];
							int u2 = states[j][i - 1];
							ull nh = hashes[j] + change(u1, i, u2) + change(i, u1, -1) + change(u2, i - 1, u1) + change(i - 1, u2, -1);
							go[last][i][j].push_back({mask | 1, ind_state[nh], 0, 1});
						}
					} else if (states[j][i] == -1 && states[j][i - 1] == -1) {
						if (!last) {
							ull nh = hashes[j] + change(i, -1, i - 1) + change(i - 1, -1, i);
							go[last][i][j].push_back({mask | 1, ind_state[nh], 0, 0});
						}
					} else if (states[j][i] == -1) {
						int e = states[j][i - 1];
						ull nh = hashes[j] + change(i, -1, e) + change(i - 1, e, -1) + change(e, i - 1, i);
						go[last][i][j].push_back({mask | 1, ind_state[nh], 0, 0});
					} else {
						if (!last) {
							int e = states[j][i];
							ull nh = hashes[j] + change(i, e, -1) + change(i - 1, -1, e) + change(e, i, i - 1);
							go[last][i][j].push_back({mask | 1, ind_state[nh], 0, 1});
						}
					}
				}
			}
		}
	}

	vector<vector<pair<int, ll>>> d(2, vector<pair<int, ll>>(szof(states), {-INF, 0}));
	vector<vector<pair<int, ll>>> next(2, vector<pair<int, ll>>(szof(states)));
	d[0][0] = {0, 1};

	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			fill(next[0].begin(), next[0].end(), make_pair(-INF, 0));
			fill(next[1].begin(), next[1].end(), make_pair(-INF, 0));
			for (int last = 0; last < 2; ++last) {
				for (int k = 0; k < szof(states); ++k) {
					for (auto [mask, st, add, nlast] : go[last][j][k]) {
						if (mask & 1) {
							if (field[j - 1][i] != field[j][i]) {
								continue;
							}
						}
						if (mask & 2) {
							if (!i || field[j][i - 1] != field[j][i]) {
								continue;
							}
						}
						if (next[nlast][st].ff < d[last][k].ff + add) {
							next[nlast][st] = {d[last][k].ff + add, d[last][k].ss};
						} else if (next[nlast][st].ff == d[last][k].ff + add) {
							next[nlast][st].ss += d[last][k].ss;
							if (next[nlast][st].ss > INFL) {
								next[nlast][st].ss = INFL;
							}
						}
					}
				}
			}
			swap(next, d);
		}
	}

	const ll threshold = 1000000000000000000ll;

	int sz = d[0][0].ff;
	ll sum = d[0][0].ss;
	if (d[1][0].ff > sz) {
		sz = d[1][0].ff;
		sum = d[1][0].ss;
	} else if (d[1][0].ff == sz) {
		sum += d[1][0].ss;
	}

	cout << sz << " ";
	if (sum > threshold) {
		cout << "-1\n";
	} else {
		cout << sum << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
