#include "testlib.h"

const int MAX_N = 100;
const int MAX_M = 100;

int main(int argc, char* argv[])
{
  registerValidation(argc, argv);
  int n = inf.readInt(1, MAX_N, "n");
  inf.readSpace();
  int m = inf.readInt(1, MAX_M, "m");
  inf.readEoln();
  for (int i = 0; i < n; i++) {
    std::string s = inf.readToken();
    inf.readEoln();
    ensuref(s.size() == m, "%d row of array `p` should have length %d", i + 1, m);
    for (int j = 0; j < m; j++) {
      ensuref(s[j] == 'R' || s[j] == 'G' || s[j] == 'B' || s[j] == '.', "p[%d][%d] should be either R, G, B or .", i + 1, j + 1);
    }
  }
  for (int i = 0; i < n; i++) {
    std::string s = inf.readToken();
    inf.readEoln();
    ensuref(s.size() == m, "%d row of array `c` should have length %d", i + 1, m);
    for (int j = 0; j < m; j++) {
      ensuref('0' <= s[j] && s[j] <= '7', "c[%d][%d] should be from 0 to 7");
    }
  }
  inf.readEof();
  return 0;
}
