#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5;

void dfs(int v, vector<bool>& used, const vector<vector<int>>& g)
{
    used[v] = true;
    for (int u : g[v])
        if (!used[u])
            dfs(u, used, g);
}

int main(int argc, char* argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(2, MAXN, "n");
    inf.readEoln();
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++)
    {
        int a = inf.readInt(1, n, format("a[%d]", i + 1));
        inf.readSpace();
        int b = inf.readInt(1, n, format("b[%d]", i + 1));
        inf.readEoln();
    
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    inf.readEof();
    vector<bool> used(n, false);
    dfs(0, used, g);
    for (int i = 0; i < n; i++)
        ensuref(used[i], "Vertex %d not connected to root %d", i + 1, 1);
    return 0;
}